<?php
/**
 * DouPHP
 * --------------------------------------------------------------------------------------------------
 * 版权所有 2013-2025 漳州豆壳网络科技有限公司，并保留所有权利。
 * 网站地址: http://www.douphp.com
 * --------------------------------------------------------------------------------------------------
 * 这不是一个自由软件！您只能在遵守授权协议前提下对程序代码进行修改和使用；不允许对程序代码以任何形式任何目的的再发布。
 * 授权协议: http://www.douphp.com/license.html
 * --------------------------------------------------------------------------------------------------
 * Author: DouCo Co.,Ltd.
 * Release Date: 2025-01-02
 */
define('IN_DOUCO', true);

$_CUR = 'gallery';
require (dirname(__FILE__) . '/include/init.php');
$smarty->assign('cur', $_CUR);

// rec操作项的初始化
$rec = $check->is_rec($_REQUEST['rec']) ? $_REQUEST['rec'] : 'default';

// 图片上传
include_once (ROOT_PATH . 'include/file.class.php');
$file = new File('images/gallery/'); // 实例化类文件(文件上传路径，结尾加斜杠)

// 赋值给模板
$smarty->assign('rec', $rec);

/**
 * +----------------------------------------------------------
 * 图片列表
 * +----------------------------------------------------------
 */
if ($rec == 'default') {
    $smarty->assign('ur_here', $_LANG['gallery']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['gallery_add'],
            'href' => 'gallery.php?rec=add' 
    ));
    
    // 获取参数
    $cat_id = $check->is_number($_REQUEST['cat_id']) ? $_REQUEST['cat_id'] : 0;
    $keyword = isset($_REQUEST['keyword']) ? trim($_REQUEST['keyword']) : '';
    
    // 筛选条件
    $where = ' WHERE cat_id IN (' . $cat_id . $dou->dou_child_id('gallery_category', $cat_id) . ')';
    if ($keyword) {
        $where = $where . " AND title LIKE '%$keyword%'";
        $get = '&keyword=' . $keyword;
    }
 
    // 排序
    $sort = $_OPEN['sort'] ? "sort ASC, " : '';
    
    // 未加入分页条件的SQL语句
    $sql = "SELECT id, title, cat_id, image, sort, add_time FROM " . $dou->table('gallery') . $where . " ORDER BY " . $sort . "id DESC";
    
    // 分页
    $page = $check->is_number($_REQUEST['page']) ? $_REQUEST['page'] : 1;
    $page_url = 'gallery.php' . ($cat_id ? '?cat_id=' . $cat_id : '');
    $limit = $dou->pager($sql, 15, $page, $page_url, $get);
    
    $sql = $sql . $limit; // 加入分页条件的SQL语句
    $query = $dou->query($sql);
    while ($row = $dou->fetch_array($query)) {
        $cat_name = $dou->get_one("SELECT cat_name FROM " . $dou->table('gallery_category') . " WHERE cat_id = '$row[cat_id]'");
        $add_time = date("Y-m-d", $row['add_time']);
        
        $gallery_list[] = array (
                "id" => $row['id'],
                "cat_id" => $row['cat_id'],
                "cat_name" => $cat_name,
                "title" => $row['title'],
                "image" => $dou->dou_file($row['image']),
                "sort" => $row['sort'],
                "add_time" => $add_time 
        );
    }
    
    // 赋值给模板
    $smarty->assign('cat_id', $cat_id);
    $smarty->assign('keyword', $keyword);
    $smarty->assign('gallery_category', $dou->get_category_nolevel('gallery_category'));
    $smarty->assign('gallery_list', $gallery_list);
    
    $smarty->display('gallery.htm');
} 

/**
 * +----------------------------------------------------------
 * 图片添加
 * +----------------------------------------------------------
 */
elseif ($rec == 'add') {
    $smarty->assign('ur_here', $_LANG['gallery_add']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['gallery'],
            'href' => 'gallery.php' 
    ));
    
    // 格式化自定义参数，并存到数组$gallery，图片编辑页面中调用图片详情也是用数组$gallery，
    if ($_DEFINED['gallery']) {
        $defined = explode(',', $_DEFINED['gallery']);
        foreach ($defined as $row) {
            $defined_gallery .= $row . "：\n";
        }
        $gallery['defined'] = trim($defined_gallery);
        $gallery['defined_count'] = count(explode("\n", $gallery['defined'])) * 2;
    }
 
    // 格式化
    $item_id = $dou->auto_id('gallery');
    $gallery['img_list_html'] = $dou->get_file_list('gallery', $item_id, 'gallery');
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'insert');
    $smarty->assign('gallery_category', $dou->get_category_nolevel('gallery_category'));
    $smarty->assign('item_id', $item_id);
    $smarty->assign('gallery', $gallery);
    $smarty->assign('btn_lang', $dou->btn_lang('gallery', '', 'title, content, keywords, description'));
    
    $smarty->display('gallery.htm');
} 

elseif ($rec == 'insert') {
    // 验证标题
    if (empty($_POST['title'])) $dou->dou_msg($_LANG['gallery_title'] . $_LANG['is_empty']);
    
    // 文件上传盒子
    $image = $file->box('gallery', $dou->auto_id('gallery'), 'image', 'main');
    
    // 数据格式化
    $add_time = time();
    $gallery = serialize($_POST['gallery']);
        
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "INSERT INTO " . $dou->table('gallery') . " (id, cat_id, title, image, gallery ,keywords, description, sort, add_time)" . " VALUES (NULL, '$_POST[cat_id]', '$_POST[title]', '$image', '$gallery', '$_POST[keywords]', '$_POST[description]', '$_POST[sort]', '$add_time')";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['gallery_add'] . ': ' . $_POST['title']);
    $dou->dou_msg($_LANG['gallery_add_succes'], 'gallery.php');
} 

/**
 * +----------------------------------------------------------
 * 图片编辑
 * +----------------------------------------------------------
 */
elseif ($rec == 'edit') {
    $smarty->assign('ur_here', $_LANG['gallery_edit']);
    $smarty->assign('action_link', array (
            'text' => $_LANG['gallery'],
            'href' => 'gallery.php' 
    ));
    
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : '';
    
    $gallery = $dou->get_row('gallery', '*', "id = '$id'");
    
    // 格式化数据
    $gallery['image'] = $dou->dou_file($gallery['image']);
    $gallery['img_list_html'] = $dou->get_file_list('gallery', $id, 'gallery');
    
    // CSRF防御令牌生成
    $smarty->assign('token', $token = $firewall->get_token());
    
    // 赋值给模板
    $smarty->assign('form_action', 'update');
    $smarty->assign('gallery_category', $dou->get_category_nolevel('gallery_category'));
    $smarty->assign('item_id', $id);
    $smarty->assign('item_content', $gallery['content']);
    $smarty->assign('gallery', $gallery);
    $smarty->assign('btn_lang', $dou->btn_lang('gallery', $id, 'title, content, keywords, description'));
    
    $smarty->display('gallery.htm');
} 

elseif ($rec == 'update') {
    // 验证并获取合法的ID
    $id = $check->is_number($_POST['id']) ? $_POST['id'] : '';
    
    // 验证标题
    if (empty($_POST['title'])) $dou->dou_msg($_LANG['gallery_title'] . $_LANG['is_empty']);
        
    // 文件上传盒子
    $image = $file->box('gallery', $id, 'image', 'main');
    $image = $image ? ", image = '" . $image . "'" : '';
    
    // 格式化数据
    $_POST['defined'] = str_replace("\r\n", ',', $_POST['defined']);
    $gallery = serialize($_POST['gallery']);
    
    // CSRF防御令牌验证
    $firewall->check_token($_POST['token']);
    
    $sql = "UPDATE " . $dou->table('gallery') . " SET cat_id = '$_POST[cat_id]', title = '$_POST[title]'" . $image . ", gallery = '$gallery', keywords = '$_POST[keywords]', description = '$_POST[description]', sort = '$_POST[sort]' WHERE id = '$id'";
    $dou->query($sql);
    
    $dou->create_admin_log($_LANG['gallery_edit'] . ': ' . $_POST['title']);
    $dou->dou_msg($_LANG['gallery_edit_succes'], 'gallery.php');
} 

/**
 * +----------------------------------------------------------
 * 图片删除
 * +----------------------------------------------------------
 */
elseif ($rec == 'del') {
    // 验证并获取合法的ID
    $id = $check->is_number($_REQUEST['id']) ? $_REQUEST['id'] : $dou->dou_msg($_LANG['illegal'], 'gallery.php');
    $title = $dou->get_one("SELECT title FROM " . $dou->table('gallery') . " WHERE id = '$id'");
    
    if (isset($_POST['confirm'])) {
        // 删除相应商品图片
        $image = $dou->get_one("SELECT image FROM " . $dou->table('gallery') . " WHERE id = '$id'");
        $dou->del_file($image);
     
        // 删除对应语言项
        if ($_OPEN['language'])
            $dou->del_lang_value('gallery', $id);
        
        $dou->create_admin_log($_LANG['gallery_del'] . ': ' . $title);
        $dou->delete('gallery', "id = $id", 'gallery.php');
    } else {
        $_LANG['del_check'] = preg_replace('/d%/Ums', $title, $_LANG['del_check']);
        $dou->dou_msg($_LANG['del_check'], 'gallery.php', '', '30', "gallery.php?rec=del&id=$id");
    }
} 

/**
 * +----------------------------------------------------------
 * 批量操作选择
 * +----------------------------------------------------------
 */
elseif ($rec == 'action') {
    if (is_array($_POST['checkbox'])) {
        if ($_POST['action'] == 'del_all') {
            // 批量图片删除
            $dou->del_all('gallery', $_POST['checkbox'], 'id', 'image');
        } elseif ($_POST['action'] == 'category_move') {
            // 批量移动分类
            $dou->category_move('gallery', $_POST['checkbox'], $_POST['new_cat_id']);
        } else {
            $dou->dou_msg($_LANG['select_empty']);
        }
    } else {
        $dou->dou_msg($_LANG['gallery_select_empty']);
    }
}

?>